package CodeGen;

/**
 * Contains methods that generate code to represent a module
 * @author Galia
 *
 */
public interface IModuleGen {
	/**
	 * when called add a comment for the module
	 */
	void genComment();
	
	/**
	 * when called add code for a method called getName that returns the name of the module as a string
	 */
	void genGetName();	

	/**
	 * Generates code to deal with all the methods the module has
	 */
	void genMethodCode();	
	
	/**
	 * Generate code save it at the given file path
	 * @param filePath where to save the output
	 * @return
	 */
	public String genCode(String filePath);
	
	/**
	 * Generate code and print it to the console
	 * @return
	 */
	public String genCode();
	
}
