package MDL;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Method {
	private String comment;
	private String name;
	private Collection<Param> params;
	
	public Method(String name, String comment){
		this.comment = comment;
		this.name = name;
		this.params = new ArrayList<Param>();
	}
	
	/**
	 * add parameters to this method
	 * @param p - paremeter to add
	 */
	public void addParam(Param p){
		params.add(p);
	}
	
	/**
	 * 	Getter
	 * @return comment
	 */
	public String getComment() {
		return comment;
	}
	/**
	 * 	Getter
	 * @return name
	 */
	public String getName() {
		return name;
	}
	/**
	 * 	Getter
	 * @return Iterator for parameters
	 */
	public Iterator<Param> getParams() {
		return params.iterator();
	}

	/**
	 * 	Does this Method havea comment
	 * @return comment
	 */
	public boolean hasComment() {
		return this.comment !=null && this.comment!="";
	}
}
