package javaCodeGen;

import CodeGen.IParamGen;
import MDL.*;

public class ParamJavaGen extends JavaElement implements IParamGen{
	private Param p;	
	
	public ParamJavaGen(Param param) {
		this.p = param;
	}
	
	@Override
	public String getComment(){
		return p.getComment(); 	
	}
	
	@Override
	public String getType(){
		return getDataType().getType(p.getLength());
	}

	@Override
	public int getLength(){
		return p.getLength();	  
	}
	@Override
	public boolean isConstant(){
		return p.isConstant();
	}
	
	@Override
	public String getName() {
		return p.getName();
	}

	@Override
	public String valueAsByteArray() {
		String result;
		if(p.isConstant()){
			String[] byteRep = getDataType().getByteArrayRep(p.getValue(), p.getLength());
			result = "{";
			for(int i = 0; i<getLength(); i++){
				result += byteRep[i] +", ";
			}
			result +="}";
		}else{
			result = "new byte["+p.getLength()+"]";
		}
		return result;
	}
	
	@Override
	public void getGetter(String name, int depthIntoPacket){		
		setI(1);
		//print comments
		addL("/**");
		addL(" *gets the value of " + name);
		addL(" *@param dataPacket : the packet to parse");
		addL(" *should be formatted like a " + name + "packet");
		addL(" *@Exception if it itnot the proper type of packet");
		addL(" *@return " + name + ":" + p.getComment());
		addL(" */");

		//print signature
		addL("public static " + getType() + " get"+ name +"_" +p.getName() + "(byte[] datapacket)throws Exception{");		
		addL("if(!Servo.is"+ name +"Packet(datapacket)){ throw new Exception();}");
		addL("int depthIntoPacket = " + depthIntoPacket +";", 1);
		addL("byte[] component = new byte[" + p.getLength()+"];", 1);
		addL("for(int i=0;i < "+p.getLength()+"; i++){",1);
		addL("component[i] = datapacket[i+ depthIntoPacket];", 2); 
		addL("}",1);
		getDataType().genByteArrayConverstion("component");

		addL("}");
		setI();
	}

	
	private JavaDataType getDataType(){
		return JavaDataType.getDataType(p.getType());
	}


}
